<template>
    <div class="cart-container">
        <template v-if="cars.length != 0">
            <div class="cart-head">
                <div class="table-responsive">
                    <table class="table table-borderless">
                        <thead>
                            <tr>
                                <th scope="col">#</th>
                                <th scope="col">Acción</th>
                                <th scope="col"></th>
                                <th scope="col">Producto</th>

                                <th scope="col" class="text-right">Total</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="(item, i) in cars" :key="item.id">
                                <th scope="row">{{ i + 1 }}</th>
                                <td>
                                    <a
                                        type="button"
                                        @click.prevent="quitarCarrito(item.id)"
                                        class="text-danger"
                                    >
                                        <i class="feather icon-trash"></i>
                                    </a>
                                </td>
                                <td>
                                    <img
                                        :src="item.image"
                                        class="img-fluid"
                                        width="35"
                                        alt="product"
                                    />
                                </td>
                                <td>{{ item.title }}</td>

                                <td class="text-right">$ {{ item.price }}</td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </div>
            <div class="cart-body">
                <div class="row">
                    <div class="col-md-12 order-2 order-lg-1 col-lg-5 col-xl-6">
                        <div class="order-note">
                            <div class="form-group">
                                <div class="input-group">
                                    <input
                                        type="search"
                                        class="form-control"
                                        placeholder="Codigo promocional"
                                        aria-label="Search"
                                        aria-describedby="button-addonTags"
                                        v-model="cupon"
                                    />
                                    <div class="input-group-append">
                                        <button
                                            class="input-group-text"
                                            id="button-addonTags"
                                            @click.prevent="aplicarCupon()"
                                        >
                                            Aplicar
                                        </button>
                                    </div>
                                </div>
                            </div>
                            <p v-if="error" class="text-danger text-justify">
                                {{ error }}
                            </p>
                            <p v-if="success" class="text-success text-justify">
                                {{ success }}
                            </p>
                        </div>
                    </div>
                    <div class="col-md-12 order-1 order-lg-2 col-lg-7 col-xl-6">
                        <div class="order-total table-responsive ">
                            <table class="table table-borderless text-right">
                                <tbody>
                                    <tr>
                                        <td>Sub Total :</td>
                                        <td>${{ subTotal }}</td>
                                    </tr>
                                    <tr v-if="cupon_active">
                                        <td>
                                            Descuento({{
                                                cupon_active.percent_desc
                                                    ? cupon_active.percent_desc +
                                                      "%"
                                                    : cupon_active.value_desc +
                                                      "$"
                                            }})
                                        </td>
                                        <td v-if="cupon_active.percent_desc">
                                            $ {{ desc_perc }}
                                        </td>
                                        <td v-if="cupon_active.value_desc">
                                            ${{ desc_val }}
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>IVA(0%) :</td>
                                        <td>$0</td>
                                    </tr>
                                    <tr>
                                        <td class="text-black f-w-7 font-18">
                                            Total :
                                        </td>
                                        <td class="text-black f-w-7 font-18">
                                            $ {{ total }}
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
            <div class="cart-footer text-right">
                <button
                    v-if="!auth"
                    v-on:click.prevent="login()"
                    class="btn btn-success-rgba my-1"
                >
                    Procesar inscripción<i
                        class="feather icon-arrow-right ml-2"
                    ></i>
                </button>
                <button
                    v-if="auth"
                    v-on:click.prevent="pedido()"
                    class="btn btn-success-rgba my-1"
                >
                    Procesar inscripción<i
                        class="feather icon-arrow-right ml-2"
                    ></i>
                </button>
            </div>
        </template>
        <template v-else>
            <h4>No ha agregado ningun elemento a la planilla de inscripción, <a href="/">click aquí para ver los cursos disponibles</a></h4>
        </template>
    </div>
</template>

<script>
export default {
    props: ["auth"],
    mounted() {
        this.get();
    },
    data() {
        return {
            cars: [],
            subTotal: "",
            iva: "",
            total: "",
            cupon: "",
            error: "",
            success: "",
            cupon_active: "",
            desc_perc: "",
            desc_val: ""
        };
    },
    methods: {
        get() {
            this.subTotal = "";
            this.cars = localStorage.getItem("car");
            if(this.cars){
              this.cars = JSON.parse(this.cars)
            }else{
                return false
            }
            this.cars.forEach(e => {
                this.subTotal = Number(this.subTotal) + Number(e.price);
            });
            this.iva = Number(this.subTotal) * 0;
            this.total = Number(this.subTotal) + Number(this.iva);
        },
        quitarCarrito(i) {
            let cars = JSON.parse(localStorage.getItem("car"));
            cars = cars.filter(e => e.id != i);
            localStorage.setItem("car", JSON.stringify(cars));
            this.get();
            this.$emit("verifycar");
        },
        aplicarCupon() {
            this.error = "";
            this.success = "";
            this.get();
            if (this.cupon && !this.cupon_active) {
                axios.get("/api/config/promo-code/" + this.cupon).then(res => {
                    console.log(res.data);
                    if (res.data.error) {
                        this.error = res.data.message;
                    } else {
                        $("#button-addonTags").attr("disabled", true);
                        this.cupon_active = res.data;
                        if (this.cupon_active.percent_desc) {
                            this.desc_perc =
                                (this.total * this.cupon_active.percent_desc) /
                                100;
                            this.total = this.total - this.desc_perc;
                            this.success =
                                "Se ha aplicado satisfactoriamente el codigo de promoción " +
                                this.code +
                                "obteniendo un descuento de " +
                                this.cupon_active.percent_desc +
                                "% por el valor todal de la inscripción.";
                        } else {
                            this.desc_val = this.cupon_active.value_desc;
                            this.total = this.total - this.desc_val;
                            this.success =
                                "Se ha aplicado satisfactoriamente el codigo de promoción " +
                                this.code +
                                "obteniendo un descuento de " +
                                this.cupon_active.percent_val +
                                "$ por el valor todal de la inscripción.";
                        }
                    }
                });
            } else {
                this.error = "Debe agregar un cupon valido.";
            }
        },
        login() {
            location.href =
                location.origin + "/login?redirect_to=" + location.href;
        },
        pedido() {
            let order;
            if (this.cupon_active) {
                order = {
                    total: this.total,
                    user: this.auth.id,
                    cars: this.cars,
                    cupon: this.cupon_active.id
                };
            } else {
                order = {
                    total: this.total,
                    user: this.auth.id,
                    cars: this.cars
                };
            }
            axios.post("/api/accounting/orders", order).then(res => {
                localStorage.setItem("car", "");
                sessionStorage.setItem("order", JSON.stringify(res.data));
                location.href = "/checkout";
            });
        }
    }
};
</script>
